/**
 * Represents event arguments for FDC3 MessageRecived
*/
export class IgcStockChangedEventArgs {
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    /**
     * Gets array of added stock symbols
    */
    get addedSymbols() {
        return this.i.addedSymbols;
    }
    set addedSymbols(v) {
        if (v && !Array.isArray(v) && typeof (v) == "string") {
            const re = /\s*(?:,|\s|$)\s*/gm;
            v = v.split(re);
        }
        this.i.addedSymbols = v;
    }
    /**
     * Gets array of removed stock symbols
    */
    get removedSymbols() {
        return this.i.removedSymbols;
    }
    set removedSymbols(v) {
        if (v && !Array.isArray(v) && typeof (v) == "string") {
            const re = /\s*(?:,|\s|$)\s*/gm;
            v = v.split(re);
        }
        this.i.removedSymbols = v;
    }
}
