import * as tslib_1 from "tslib";
import { IgcDataLegendSeriesValueInfo } from "./igc-data-legend-series-value-info";
import { DataLegendSummaryColumn as DataLegendSummaryColumn_internal } from "./DataLegendSummaryColumn";
/**
 * Represent a column in summary row
*/
var IgcDataLegendSummaryColumn = /** @class */ /*@__PURE__*/ (function (_super) {
    tslib_1.__extends(IgcDataLegendSummaryColumn, _super);
    function IgcDataLegendSummaryColumn() {
        return _super.call(this) || this;
    }
    IgcDataLegendSummaryColumn.prototype.createImplementation = function () {
        return new DataLegendSummaryColumn_internal();
    };
    Object.defineProperty(IgcDataLegendSummaryColumn.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgcDataLegendSummaryColumn.prototype, "seriesValues", {
        /**
         * Get values of series in the summary column
        */
        get: function () {
            return this.i.aa;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgcDataLegendSummaryColumn.prototype, "seriesLabels", {
        /**
         * Get labels rendered on left side of series values, e.g. "H:" for High, "L:" for Low
        */
        get: function () {
            return this.i.y;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgcDataLegendSummaryColumn.prototype, "seriesUnits", {
        /**
         * Get optional units on right side of series values, e.g. "Hz" for hertz
        */
        get: function () {
            return this.i.z;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * Add a value in the summary column
    
    */
    IgcDataLegendSummaryColumn.prototype.addValue = function (value) {
        this.i.ai(value);
    };
    /**
     * Add label in the summary column
    
    */
    IgcDataLegendSummaryColumn.prototype.addLabel = function (label) {
        this.i.ag(label);
    };
    /**
     * Add unit in the summary column
    
    */
    IgcDataLegendSummaryColumn.prototype.addUnits = function (units) {
        this.i.ah(units);
    };
    return IgcDataLegendSummaryColumn;
}(IgcDataLegendSeriesValueInfo));
export { IgcDataLegendSummaryColumn };
