import { Description } from "./Description";
import { SectionHeaderDescription } from "./SectionHeaderDescription";
import { SummaryRowRootDescription } from "./SummaryRowRootDescription";
import { SummaryRowSectionDescription } from "./SummaryRowSectionDescription";
import { RowSeparatorDescription } from "./RowSeparatorDescription";
import { HeaderRowSeparatorDescription } from "./HeaderRowSeparatorDescription";
import { HeaderSeparatorDescription } from "./HeaderSeparatorDescription";
import { ColumnResizingSeparatorDescription } from "./ColumnResizingSeparatorDescription";
import { ColumnMovingSeparatorDescription } from "./ColumnMovingSeparatorDescription";
import { PinnedAreaSeparatorDescription } from "./PinnedAreaSeparatorDescription";
import { BaseDataSourceDescription } from "./BaseDataSourceDescription";
import { GridAnimationSettingsDescription } from "./GridAnimationSettingsDescription";
import { Type } from "./type";
import { PrimaryKeyValueDescription } from "./PrimaryKeyValueDescription";
import { CellKeyDescription } from "./CellKeyDescription";
import { CellRangeDescription } from "./CellRangeDescription";
import { GridCellPositionDescription } from "./GridCellPositionDescription";
import { ResponsiveStateDescription } from "./ResponsiveStateDescription";
import { ColumnSortDescriptionDescription } from "./ColumnSortDescriptionDescription";
import { ColumnGroupDescriptionDescription } from "./ColumnGroupDescriptionDescription";
import { ColumnSummaryDescriptionDescription } from "./ColumnSummaryDescriptionDescription";
import { FilterExpressionDescription } from "./FilterExpressionDescription";
import { DataGridColumnDescription } from "./DataGridColumnDescription";
/**
 * @hidden
 */
export declare class DataGridDescription extends Description {
    static $t: Type;
    private iu;
    width: string;
    private g0;
    height: string;
    private e4;
    background: string;
    private br;
    isGroupByAreaVisible: boolean;
    private bw;
    isPagerVisible: boolean;
    private b1;
    isToolbarVisible: boolean;
    protected get_type(): string;
    readonly type: string;
    constructor();
    private fz;
    columnResizingMode: string;
    private fr;
    columnMovingMode: string;
    private by;
    isRowHoverEnabled: boolean;
    private hc;
    rowHoverBackground: string;
    private hd;
    rowHoverTextColor: string;
    private gf;
    editRowBorder: string;
    private df;
    editRowBorderWidthBottom: number;
    private dg;
    editRowBorderWidthLeft: number;
    private dh;
    editRowBorderWidthRight: number;
    private di;
    editRowBorderWidthTop: number;
    private bb;
    sectionHeader: SectionHeaderDescription;
    private bd;
    summaryRowRoot: SummaryRowRootDescription;
    private bf;
    summaryRowSection: SummaryRowSectionDescription;
    private a9;
    rowSeparator: RowSeparatorDescription;
    private a3;
    headerRowSeparator: HeaderRowSeparatorDescription;
    private a5;
    headerSeparator: HeaderSeparatorDescription;
    private ax;
    columnResizingSeparator: ColumnResizingSeparatorDescription;
    private av;
    columnMovingSeparator: ColumnMovingSeparatorDescription;
    private a7;
    pinnedAreaSeparator: PinnedAreaSeparatorDescription;
    private h;
    autoGenerateDesiredProperties: string[];
    private j;
    dataSourceDesiredProperties: string[];
    private f9;
    density: string;
    private eh;
    actualRowHeight: number;
    private eo;
    rowHeight: number;
    private dc;
    defaultColumnMinWidth: number;
    private eg;
    actualHeaderHeight: number;
    private ek;
    headerHeight: number;
    private f7;
    dataSourceRef: string;
    private at;
    dataSource: BaseDataSourceDescription;
    private gr;
    headerClickAction: string;
    private gd;
    editMode: string;
    private ge;
    editModeClickAction: string;
    private bm;
    editOnKeyPress: boolean;
    private bj;
    autoGenerateColumns: boolean;
    private ep;
    rowSeparatorHeight: number;
    private bx;
    isPlaceholderRenderingEnabled: boolean;
    private fm;
    columnAddingAnimationMode: string;
    private fx;
    columnPropertyUpdatingAnimationMode: string;
    private e8;
    cellDataLoadedAnimationMode: string;
    private he;
    rowSelectionAnimationMode: string;
    private hb;
    rowHoverAnimationMode: string;
    private fj;
    cellSelectionAnimationMode: string;
    private az;
    animationSettings: GridAnimationSettingsDescription;
    private fy;
    columnResizingAnimationMode: string;
    private f2;
    columnShowingAnimationMode: string;
    private fq;
    columnMovingAnimationMode: string;
    private fp;
    columnHidingAnimationMode: string;
    private fn;
    columnExchangingAnimationMode: string;
    private hx;
    selectionMode: string;
    private e0;
    activationMode: string;
    private hv;
    selectionBehavior: string;
    private b2;
    mouseDragSelectionEnabled: boolean;
    private v;
    selectedItems: any[];
    private w;
    selectedKeys: PrimaryKeyValueDescription[];
    private u;
    selectedCells: CellKeyDescription[];
    private t;
    selectedCellRanges: CellRangeDescription[];
    private p;
    pinnedItems: any[];
    private q;
    pinnedKeys: PrimaryKeyValueDescription[];
    private bo;
    isColumnOptionsEnabled: boolean;
    private bu;
    isGroupRowSticky: boolean;
    private bv;
    isHeaderSeparatorVisible: boolean;
    private fi;
    cellSelectedBackground: string;
    private hp;
    sectionHeaderSelectedBackground: string;
    private h2;
    summaryRootBackground: string;
    private id;
    summarySectionBackground: string;
    private dk;
    pinnedRowOpacity: number;
    private ga;
    editFontFamily: string;
    private dd;
    editFontSize: number;
    private gb;
    editFontStyle: string;
    private gc;
    editFontWeight: string;
    private de;
    editOpacity: number;
    private f8;
    deletedTextColor: string;
    private h0;
    stickyRowBackground: string;
    private g8;
    pinnedRowBackground: string;
    private g4;
    lastStickyRowBackground: string;
    private a1;
    activeCell: GridCellPositionDescription;
    private e6;
    cellBackground: string;
    private fk;
    cellTextColor: string;
    private gx;
    headerSortIndicatorColor: string;
    private gy;
    headerSortIndicatorStyle: string;
    private fb;
    cellFontFamily: string;
    private c5;
    cellFontSize: number;
    private fc;
    cellFontStyle: string;
    private fd;
    cellFontWeight: string;
    private hl;
    sectionHeaderBackground: string;
    private hq;
    sectionHeaderTextColor: string;
    private hm;
    sectionHeaderFontFamily: string;
    private dl;
    sectionHeaderFontSize: number;
    private hn;
    sectionHeaderFontStyle: string;
    private ho;
    sectionHeaderFontWeight: string;
    private h3;
    summaryRootLabelFontFamily: string;
    private dm;
    summaryRootLabelFontSize: number;
    private h4;
    summaryRootLabelFontStyle: string;
    private h5;
    summaryRootLabelFontWeight: string;
    private ie;
    summarySectionLabelFontFamily: string;
    private dp;
    summarySectionLabelFontSize: number;
    private ig;
    summarySectionLabelFontStyle: string;
    private ih;
    summarySectionLabelFontWeight: string;
    private ib;
    summaryRootValueTextColor: string;
    private h8;
    summaryRootValueFontFamily: string;
    private dn;
    summaryRootValueFontSize: number;
    private h9;
    summaryRootValueFontStyle: string;
    private ia;
    summaryRootValueFontWeight: string;
    private ik;
    summarySectionValueFontFamily: string;
    private dq;
    summarySectionValueFontSize: number;
    private il;
    summarySectionValueFontStyle: string;
    private im;
    summarySectionValueFontWeight: string;
    private io;
    summarySectionValueTextColor: string;
    private h6;
    summaryRootLabelTextColor: string;
    private ii;
    summarySectionLabelTextColor: string;
    private h7;
    summaryRootSelectedBackground: string;
    private ij;
    summarySectionSelectedBackground: string;
    private en;
    pinnedAreaSeparatorWidth: number;
    private el;
    headerSeparatorWidth: number;
    private gw;
    headerSeparatorBackground: string;
    private gq;
    headerBackground: string;
    private gz;
    headerTextColor: string;
    private gs;
    headerFontFamily: string;
    private dj;
    headerFontSize: number;
    private gt;
    headerFontStyle: string;
    private gu;
    headerFontWeight: string;
    private hf;
    rowSeparatorBackground: string;
    private gv;
    headerRowSeparatorBackground: string;
    private hi;
    rowSeparatorStickyRowBackground: string;
    private hg;
    rowSeparatorLastStickyRowBackground: string;
    private hh;
    rowSeparatorPinnedRowBackground: string;
    private ej;
    columnResizingSeparatorWidth: number;
    private c7;
    columnResizingSeparatorOpacity: number;
    private ei;
    columnMovingSeparatorWidth: number;
    private c6;
    columnMovingSeparatorOpacity: number;
    private f0;
    columnResizingSeparatorBackground: string;
    private fs;
    columnMovingSeparatorBackground: string;
    private b7;
    shiftSectionContent: boolean;
    private ft;
    columnOptionsIconAlignment: string;
    private fv;
    columnOptionsIconColor: string;
    private fu;
    columnOptionsIconBehavior: string;
    private e5;
    border: string;
    private c1;
    borderWidthBottom: number;
    private c2;
    borderWidthLeft: number;
    private c3;
    borderWidthRight: number;
    private c4;
    borderWidthTop: number;
    private b3;
    notifyOnAllSelectionChanges: boolean;
    private c9;
    cornerRadiusBottomRight: number;
    private c8;
    cornerRadiusBottomLeft: number;
    private da;
    cornerRadiusTopLeft: number;
    private db;
    cornerRadiusTopRight: number;
    private bn;
    isActiveCellStyleEnabled: boolean;
    private s;
    responsiveStates: ResponsiveStateDescription[];
    private n;
    initialSortDescriptions: ColumnSortDescriptionDescription[];
    private m;
    initialGroupDescriptions: ColumnGroupDescriptionDescription[];
    private o;
    initialSummaryDescriptions: ColumnSummaryDescriptionDescription[];
    private g2;
    initialSorts: string;
    private g1;
    initialGroups: string;
    private g3;
    initialSummaries: string;
    private x;
    sortDescriptions: ColumnSortDescriptionDescription[];
    private l;
    groupDescriptions: ColumnGroupDescriptionDescription[];
    private k;
    filterExpressions: FilterExpressionDescription[];
    private y;
    summaryDescriptions: ColumnSummaryDescriptionDescription[];
    private ic;
    summaryScope: string;
    private bs;
    isGroupCollapsable: boolean;
    private go;
    groupHeaderDisplayMode: string;
    private bt;
    isGroupExpandedDefault: boolean;
    private gp;
    groupSummaryDisplayMode: string;
    private bi;
    autoAcceptEdits: boolean;
    private r;
    primaryKey: string[];
    private g;
    actualPrimaryKey: string[];
    private f;
    actualColumns: DataGridColumnDescription[];
    private i;
    columns: DataGridColumnDescription[];
    private b6;
    reactsToSortChanges: boolean;
    private b5;
    reactsToGroupChanges: boolean;
    private b4;
    reactsToFilterChanges: boolean;
    private gg;
    enterBehavior: string;
    private gh;
    enterBehaviorAfterEdit: string;
    private bq;
    isColumnOptionsSummariesEnabled: boolean;
    private bp;
    isColumnOptionsGroupingEnabled: boolean;
    private g6;
    mergedCellMode: string;
    private g5;
    mergedCellEvaluationCriteria: string;
    private g7;
    mergedCellVerticalAlignment: string;
    private gm;
    filterUIType: string;
    private gl;
    filterLogicalOperator: string;
    private gi;
    filterComparisonType: string;
    private cz;
    todayOverride: Date;
    private bk;
    clearSelectionOnEscape: boolean;
    private em;
    pageSize: number;
    private bz;
    isToolbarColumnChooserVisible: boolean;
    private b0;
    isToolbarColumnPinningVisible: boolean;
    private it;
    toolbarTitle: string;
    private ip;
    toolbarColumnChooserText: string;
    private iq;
    toolbarColumnChooserTitle: string;
    private ir;
    toolbarColumnPinningText: string;
    private is;
    toolbarColumnPinningTitle: string;
    private hk;
    scrollbarStyle: string;
    private hj;
    scrollbarBackground: string;
    private bh;
    allowCopyOperation: boolean;
    private bl;
    deferEventForRowDragSelection: boolean;
    private gk;
    filterExpressionsChangingRef: string;
    private gj;
    filterExpressionsChangedRef: string;
    private fg;
    cellPreviewPointerDownRef: string;
    private fh;
    cellPreviewPointerUpRef: string;
    private fe;
    cellPointerDownRef: string;
    private ff;
    cellPointerUpRef: string;
    private e7;
    cellClickedRef: string;
    private hz;
    sortDescriptionsChangedRef: string;
    private gn;
    groupDescriptionsChangedRef: string;
    private h1;
    summaryDescriptionsChangedRef: string;
    private fo;
    columnHiddenChangedRef: string;
    private fw;
    columnPinnedChangedRef: string;
    private fl;
    cellValueChangingRef: string;
    private f5;
    dataCommittedRef: string;
    private f6;
    dataCommittingRef: string;
    private hy;
    sizeChangedRef: string;
    private e2;
    actualColumnsChangedRef: string;
    private f1;
    columnsAutoGeneratedRef: string;
    private ht;
    selectedItemsChangedRef: string;
    private hu;
    selectedKeysChangedRef: string;
    private hs;
    selectedCellsChangedRef: string;
    private hw;
    selectionChangedRef: string;
    private e1;
    activeCellChangedRef: string;
    private hr;
    selectedCellRangesChangedRef: string;
    private f3;
    columnWidthChangedRef: string;
    private fa;
    cellEditStartedRef: string;
    private e9;
    cellEditEndedRef: string;
    private ha;
    rowEditStartedRef: string;
    private g9;
    rowEditEndedRef: string;
    private f4;
    customFilterRequestedRef: string;
    private e3;
    actualPrimaryKeyChangeRef: string;
}
