import { Type } from "./type";
/**
 * Describes mode for displaying units after series values in the data legend.
 */
export declare enum DataLegendUnitsMode {
    /**
     * Specifies automatic visibility of units based on series type
     */
    Auto = 0,
    /**
     * Specifies always visible units after series values
     */
    Visible = 1,
    /**
     * Specifies hidden units after series values
     */
    Hidden = 2
}
/**
 * @hidden
 */
export declare let DataLegendUnitsMode_$type: Type;
