import { Description } from "./Description";
import { FormatSpecifierDescription } from "./FormatSpecifierDescription";
import { ChartSortDescriptionDescription } from "./ChartSortDescriptionDescription";
import { FilterExpressionDescription } from "./FilterExpressionDescription";
import { ChartSummaryDescriptionDescription } from "./ChartSummaryDescriptionDescription";
import { BaseDataSourceDescription } from "./BaseDataSourceDescription";
import { RectDescription } from "./RectDescription";
import { Type } from "./type";
/**
 * @hidden
 */
export declare abstract class DomainChartDescription extends Description {
    static $t: Type;
    protected get_type(): string;
    readonly type: string;
    constructor();
    private ea;
    pixelScalingRatio: number;
    private en;
    titleLeftMargin: number;
    private eo;
    titleRightMargin: number;
    private ep;
    titleTopMargin: number;
    private em;
    titleBottomMargin: number;
    private ei;
    subtitleLeftMargin: number;
    private ek;
    subtitleTopMargin: number;
    private ej;
    subtitleRightMargin: number;
    private eh;
    subtitleBottomMargin: number;
    private k5;
    subtitleTextColor: string;
    private k8;
    titleTextColor: string;
    private d7;
    leftMargin: number;
    private eq;
    topMargin: number;
    private eg;
    rightMargin: number;
    private cg;
    bottomMargin: number;
    private hw;
    transitionDuration: number;
    private lb;
    transitionEasingFunctionRef: string;
    private k6;
    subtitleTextStyle: string;
    private k9;
    titleTextStyle: string;
    private is;
    dataToolTipGroupingMode: string;
    private c2;
    dataToolTipPositionOffsetX: number;
    private c3;
    dataToolTipPositionOffsetY: number;
    private cm;
    dataToolTipDefaultPositionOffsetX: number;
    private cn;
    dataToolTipDefaultPositionOffsetY: number;
    private iq;
    dataToolTipGroupedPositionModeX: string;
    private ir;
    dataToolTipGroupedPositionModeY: string;
    private bg;
    dataToolTipShouldUpdateWhenSeriesDataChanges: boolean;
    private n;
    dataToolTipIncludedSeries: string[];
    private k;
    dataToolTipExcludedSeries: string[];
    private m;
    dataToolTipIncludedColumns: string[];
    private j;
    dataToolTipExcludedColumns: string[];
    private j1;
    dataToolTipValueFormatAbbreviation: string;
    private hs;
    dataToolTipValueFormatMaxFractions: number;
    private ht;
    dataToolTipValueFormatMinFractions: number;
    private j3;
    dataToolTipValueFormatMode: string;
    private j2;
    dataToolTipValueFormatCulture: string;
    private bh;
    dataToolTipValueFormatUseGrouping: boolean;
    private j4;
    dataToolTipValueFormatString: string;
    private o;
    dataToolTipValueFormatSpecifiers: FormatSpecifierDescription[];
    private dr;
    dataToolTipValueRowMarginBottom: number;
    private ds;
    dataToolTipValueRowMarginLeft: number;
    private dt;
    dataToolTipValueRowMarginRight: number;
    private du;
    dataToolTipValueRowMarginTop: number;
    private bi;
    dataToolTipValueRowVisible: boolean;
    private j9;
    dataToolTipValueTextWhenMissingData: string;
    private bj;
    dataToolTipValueTextUseSeriesColors: boolean;
    private dw;
    dataToolTipValueTextMarginBottom: number;
    private dx;
    dataToolTipValueTextMarginLeft: number;
    private dy;
    dataToolTipValueTextMarginRight: number;
    private dz;
    dataToolTipValueTextMarginTop: number;
    private j5;
    dataToolTipValueTextColor: string;
    private j6;
    dataToolTipValueTextFontFamily: string;
    private dv;
    dataToolTipValueTextFontSize: number;
    private j7;
    dataToolTipValueTextFontStyle: string;
    private j8;
    dataToolTipValueTextFontWeight: string;
    private iv;
    dataToolTipHeaderFormatString: string;
    private l;
    dataToolTipHeaderFormatSpecifiers: FormatSpecifierDescription[];
    private it;
    dataToolTipHeaderFormatCulture: string;
    private iu;
    dataToolTipHeaderFormatDate: string;
    private iw;
    dataToolTipHeaderFormatTime: string;
    private ix;
    dataToolTipHeaderText: string;
    private iy;
    dataToolTipHeaderTextColor: string;
    private ct;
    dataToolTipHeaderTextMarginBottom: number;
    private cu;
    dataToolTipHeaderTextMarginLeft: number;
    private cv;
    dataToolTipHeaderTextMarginRight: number;
    private cw;
    dataToolTipHeaderTextMarginTop: number;
    private co;
    dataToolTipHeaderRowMarginBottom: number;
    private cp;
    dataToolTipHeaderRowMarginLeft: number;
    private cq;
    dataToolTipHeaderRowMarginRight: number;
    private cr;
    dataToolTipHeaderRowMarginTop: number;
    private bf;
    dataToolTipHeaderRowVisible: boolean;
    private iz;
    dataToolTipHeaderTextFontFamily: string;
    private cs;
    dataToolTipHeaderTextFontSize: number;
    private i0;
    dataToolTipHeaderTextFontStyle: string;
    private i1;
    dataToolTipHeaderTextFontWeight: string;
    private jd;
    dataToolTipSummaryTitleTextColor: string;
    private je;
    dataToolTipSummaryTitleTextFontFamily: string;
    private c9;
    dataToolTipSummaryTitleTextFontSize: number;
    private jf;
    dataToolTipSummaryTitleTextFontStyle: string;
    private jg;
    dataToolTipSummaryTitleTextFontWeight: string;
    private jh;
    dataToolTipSummaryType: string;
    private jc;
    dataToolTipSummaryTitleText: string;
    private da;
    dataToolTipSummaryTitleTextMarginBottom: number;
    private db;
    dataToolTipSummaryTitleTextMarginLeft: number;
    private dc;
    dataToolTipSummaryTitleTextMarginRight: number;
    private dd;
    dataToolTipSummaryTitleTextMarginTop: number;
    private c5;
    dataToolTipSummaryRowMarginBottom: number;
    private c6;
    dataToolTipSummaryRowMarginLeft: number;
    private c7;
    dataToolTipSummaryRowMarginRight: number;
    private c8;
    dataToolTipSummaryRowMarginTop: number;
    private jn;
    dataToolTipSummaryValueTextColor: string;
    private jo;
    dataToolTipSummaryValueTextFontFamily: string;
    private df;
    dataToolTipSummaryValueTextFontSize: number;
    private jp;
    dataToolTipSummaryValueTextFontStyle: string;
    private jq;
    dataToolTipSummaryValueTextFontWeight: string;
    private i7;
    dataToolTipSummaryLabelText: string;
    private i8;
    dataToolTipSummaryLabelTextColor: string;
    private i9;
    dataToolTipSummaryLabelTextFontFamily: string;
    private c4;
    dataToolTipSummaryLabelTextFontSize: number;
    private ja;
    dataToolTipSummaryLabelTextFontStyle: string;
    private jb;
    dataToolTipSummaryLabelTextFontWeight: string;
    private ji;
    dataToolTipSummaryUnitsText: string;
    private jj;
    dataToolTipSummaryUnitsTextColor: string;
    private jk;
    dataToolTipSummaryUnitsTextFontFamily: string;
    private de;
    dataToolTipSummaryUnitsTextFontSize: number;
    private jl;
    dataToolTipSummaryUnitsTextFontStyle: string;
    private jm;
    dataToolTipSummaryUnitsTextFontWeight: string;
    private ci;
    dataToolTipBadgeMarginBottom: number;
    private cj;
    dataToolTipBadgeMarginLeft: number;
    private ck;
    dataToolTipBadgeMarginRight: number;
    private cl;
    dataToolTipBadgeMarginTop: number;
    private ip;
    dataToolTipBadgeShape: string;
    private jv;
    dataToolTipUnitsDisplayMode: string;
    private jw;
    dataToolTipUnitsText: string;
    private jx;
    dataToolTipUnitsTextColor: string;
    private dm;
    dataToolTipUnitsTextMarginBottom: number;
    private dn;
    dataToolTipUnitsTextMarginLeft: number;
    private dp;
    dataToolTipUnitsTextMarginRight: number;
    private dq;
    dataToolTipUnitsTextMarginTop: number;
    private jy;
    dataToolTipUnitsTextFontFamily: string;
    private dl;
    dataToolTipUnitsTextFontSize: number;
    private jz;
    dataToolTipUnitsTextFontStyle: string;
    private j0;
    dataToolTipUnitsTextFontWeight: string;
    private dh;
    dataToolTipTitleTextMarginBottom: number;
    private di;
    dataToolTipTitleTextMarginLeft: number;
    private dj;
    dataToolTipTitleTextMarginRight: number;
    private dk;
    dataToolTipTitleTextMarginTop: number;
    private jr;
    dataToolTipTitleTextColor: string;
    private js;
    dataToolTipTitleTextFontFamily: string;
    private dg;
    dataToolTipTitleTextFontSize: number;
    private jt;
    dataToolTipTitleTextFontStyle: string;
    private ju;
    dataToolTipTitleTextFontWeight: string;
    private i2;
    dataToolTipLabelDisplayMode: string;
    private i3;
    dataToolTipLabelTextColor: string;
    private cy;
    dataToolTipLabelTextMarginBottom: number;
    private cz;
    dataToolTipLabelTextMarginLeft: number;
    private c0;
    dataToolTipLabelTextMarginRight: number;
    private c1;
    dataToolTipLabelTextMarginTop: number;
    private i4;
    dataToolTipLabelTextFontFamily: string;
    private cx;
    dataToolTipLabelTextFontSize: number;
    private i5;
    dataToolTipLabelTextFontStyle: string;
    private i6;
    dataToolTipLabelTextFontWeight: string;
    private ac;
    sortDescriptions: ChartSortDescriptionDescription[];
    private s;
    groupSortDescriptions: ChartSortDescriptionDescription[];
    private r;
    groupDescriptions: ChartSortDescriptionDescription[];
    private q;
    filterExpressions: FilterExpressionDescription[];
    private ad;
    summaryDescriptions: ChartSummaryDescriptionDescription[];
    private w;
    initialSortDescriptions: ChartSortDescriptionDescription[];
    private v;
    initialGroupSortDescriptions: ChartSortDescriptionDescription[];
    private u;
    initialGroupDescriptions: ChartSortDescriptionDescription[];
    private x;
    initialSummaryDescriptions: ChartSummaryDescriptionDescription[];
    private kk;
    initialSorts: string;
    private kc;
    groupSorts: string;
    private kj;
    initialGroups: string;
    private kl;
    initialSummaries: string;
    private io;
    dataSourceRef: string;
    private a5;
    dataSource: BaseDataSourceDescription;
    private t;
    includedProperties: string[];
    private p;
    excludedProperties: string[];
    private h;
    brushes: string[];
    private ab;
    outlines: string[];
    private f;
    actualBrushes: string[];
    private g;
    actualOutlines: string[];
    private kp;
    legendRef: string;
    private bm;
    isHorizontalZoomEnabled: boolean;
    private bo;
    isVerticalZoomEnabled: boolean;
    private bq;
    shouldDisplayMockData: boolean;
    private bs;
    shouldUseSkeletonStyleForMockData: boolean;
    private bn;
    isSeriesHighlightingEnabled: boolean;
    private a7;
    windowRect: RectDescription;
    private id;
    chartTitle: string;
    private k3;
    subtitle: string;
    private k7;
    titleAlignment: string;
    private k4;
    subtitleAlignment: string;
    private ld;
    unknownValuePlotting: string;
    private ef;
    resolution: number;
    private el;
    thickness: number;
    private kt;
    outlineMode: string;
    private ks;
    markerOutlineMode: string;
    private kr;
    markerFillMode: string;
    private d8;
    markerFillOpacity: number;
    private d9;
    markerThickness: number;
    private aa;
    markerTypes: string[];
    private kq;
    markerAutomaticBehavior: string;
    private y;
    markerBrushes: string[];
    private z;
    markerOutlines: string[];
    private hv;
    markerMaxCount: number;
    private cf;
    areaFillOpacity: number;
    private ba;
    animateSeriesWhenAxisRangeChanges: boolean;
    private ae;
    trendLineBrushes: string[];
    private lc;
    trendLineType: string;
    private er;
    trendLineThickness: number;
    private a9;
    alignsGridLinesToPixels: boolean;
    private ec;
    plotAreaMarginLeft: number;
    private ee;
    plotAreaMarginTop: number;
    private ed;
    plotAreaMarginRight: number;
    private eb;
    plotAreaMarginBottom: number;
    private ie;
    computedPlotAreaMarginMode: string;
    private kv;
    seriesPlotAreaMarginHorizontalMode: string;
    private kw;
    seriesPlotAreaMarginVerticalMode: string;
    private ke;
    highlightingMode: string;
    private kd;
    highlightingBehavior: string;
    private km;
    legendHighlightingMode: string;
    private ko;
    legendItemBadgeShape: string;
    private kn;
    legendItemBadgeMode: string;
    private hx;
    trendLinePeriod: number;
    private la;
    toolTipType: string;
    private ik;
    crosshairsDisplayMode: string;
    private be;
    crosshairsSnapToData: boolean;
    private im;
    crosshairsLineVerticalStroke: string;
    private ch;
    crosshairsLineThickness: number;
    private il;
    crosshairsLineHorizontalStroke: string;
    private bd;
    crosshairsAnnotationEnabled: boolean;
    private ig;
    crosshairsAnnotationXAxisBackground: string;
    private ii;
    crosshairsAnnotationYAxisBackground: string;
    private ih;
    crosshairsAnnotationXAxisTextColor: string;
    private ij;
    crosshairsAnnotationYAxisTextColor: string;
    private hq;
    crosshairsAnnotationXAxisPrecision: number;
    private hr;
    crosshairsAnnotationYAxisPrecision: number;
    private bp;
    shouldAvoidAxisAnnotationCollisions: boolean;
    private br;
    shouldPanOnMaximumZoom: boolean;
    private bk;
    finalValueAnnotationsVisible: boolean;
    private ka;
    finalValueAnnotationsBackground: string;
    private kb;
    finalValueAnnotationsTextColor: string;
    private hu;
    finalValueAnnotationsPrecision: number;
    private bc;
    calloutsVisible: boolean;
    private bb;
    calloutStyleUpdatingEventEnabled: boolean;
    private h8;
    calloutsDataSourceRef: string;
    private i;
    calloutsAllowedPositions: string[];
    private ib;
    calloutsXMemberPath: string;
    private ic;
    calloutsYMemberPath: string;
    private h9;
    calloutsLabelMemberPath: string;
    private h7;
    calloutsContentMemberPath: string;
    private kg;
    horizontalViewScrollbarMode: string;
    private lf;
    verticalViewScrollbarMode: string;
    private ki;
    horizontalViewScrollbarPosition: string;
    private lh;
    verticalViewScrollbarPosition: string;
    private kf;
    horizontalViewScrollbarFill: string;
    private kh;
    horizontalViewScrollbarOutline: string;
    private d4;
    horizontalViewScrollbarStrokeThickness: number;
    private d3;
    horizontalViewScrollbarMaxOpacity: number;
    private d0;
    horizontalViewScrollbarCornerRadius: number;
    private d1;
    horizontalViewScrollbarHeight: number;
    private d2;
    horizontalViewScrollbarInset: number;
    private d6;
    horizontalViewScrollbarTrackStartInset: number;
    private d5;
    horizontalViewScrollbarTrackEndInset: number;
    private bl;
    horizontalViewScrollbarShouldAddAutoTrackInsets: boolean;
    private le;
    verticalViewScrollbarFill: string;
    private lg;
    verticalViewScrollbarOutline: string;
    private ev;
    verticalViewScrollbarStrokeThickness: number;
    private eu;
    verticalViewScrollbarMaxOpacity: number;
    private es;
    verticalViewScrollbarCornerRadius: number;
    private ey;
    verticalViewScrollbarWidth: number;
    private et;
    verticalViewScrollbarInset: number;
    private ex;
    verticalViewScrollbarTrackStartInset: number;
    private ew;
    verticalViewScrollbarTrackEndInset: number;
    private bt;
    verticalViewScrollbarShouldAddAutoTrackInsets: boolean;
    private e0;
    windowRectMinWidth: number;
    private ez;
    windowRectMinHeight: number;
    private e2;
    windowSizeMinWidth: number;
    private e1;
    windowSizeMinHeight: number;
    private ku;
    seriesAddedRef: string;
    private k2;
    seriesRemovedRef: string;
    private ky;
    seriesPointerEnterRef: string;
    private kz;
    seriesPointerLeaveRef: string;
    private k0;
    seriesPointerMoveRef: string;
    private kx;
    seriesPointerDownRef: string;
    private k1;
    seriesPointerUpRef: string;
    private ia;
    calloutStyleUpdatingRef: string;
    private h6;
    calloutRenderStyleUpdatingRef: string;
}
