import { Type } from "./type";
/**
 * An enumeration for the different transaction service events.
 */
export declare enum TransactionEvent {
    /**
     * An undo action has occurred.
     */
    Undo = 0,
    /**
     * A redo action has occurred.
     */
    Redo = 1,
    /**
     * Transactions have been cleared from the service.
     */
    Clear = 2,
    /**
     * A transaction was added to the service.
     */
    Add = 3,
    /**
     * Pending transactions have ended.
     */
    End = 4,
    /**
     * Transactions have been committed.
     */
    Commit = 5
}
/**
 * @hidden
 */
export declare let TransactionEvent_$type: Type;
