import { WebDisplayDensityBaseDescription } from "./WebDisplayDensityBaseDescription";
import { WebDataCloneStrategyDescription } from "./WebDataCloneStrategyDescription";
import { WebGridClipboardOptionsDescription } from "./WebGridClipboardOptionsDescription";
import { WebActionStripDescription } from "./WebActionStripDescription";
import { WebPaginatorDescription } from "./WebPaginatorDescription";
import { WebGridResourceStringsDescription } from "./WebGridResourceStringsDescription";
import { WebFilteringExpressionsTreeDescription } from "./WebFilteringExpressionsTreeDescription";
import { Type } from "./type";
import { WebPinningConfigDescription } from "./WebPinningConfigDescription";
import { WebFilteringStrategyDescription } from "./WebFilteringStrategyDescription";
import { WebGridSortingStrategyDescription } from "./WebGridSortingStrategyDescription";
import { WebSortingOptionsDescription } from "./WebSortingOptionsDescription";
import { WebSortingExpressionDescription } from "./WebSortingExpressionDescription";
import { WebOverlayOutletDirectiveDescription } from "./WebOverlayOutletDirectiveDescription";
import { WebColumnDescription } from "./WebColumnDescription";
import { WebDisplayDensityBaseElementDescription } from "./WebDisplayDensityBaseElementDescription";
import { WebGridToolbarContentDescription } from "./WebGridToolbarContentDescription";
/**
 * @hidden
 */
export declare abstract class WebGridBaseDirectiveDescription extends WebDisplayDensityBaseDescription {
    static $t: Type;
    protected get_type(): string;
    constructor();
    private bk;
    snackbarDisplayTime: number;
    private aq;
    autoGenerate: boolean;
    private aw;
    moving: boolean;
    private cr;
    emptyGridTemplateRef: string;
    private bx;
    addRowEmptyTemplateRef: string;
    private c7;
    loadingGridTemplateRef: string;
    private bl;
    summaryRowHeight: number;
    private u;
    dataCloneStrategy: WebDataCloneStrategyDescription;
    private ac;
    clipboardOptions: WebGridClipboardOptionsDescription;
    private cs;
    evenRowCSS: string;
    private c9;
    oddRowCSS: string;
    private dk;
    rowClassesRef: string;
    private d3;
    rowStylesRef: string;
    private de;
    primaryKey: string;
    private s;
    actionStrip: WebActionStripDescription;
    private co;
    emptyFilteredGridTemplateRef: string;
    private cp;
    emptyGridDefaultTemplateRef: string;
    private cl;
    dragGhostCustomTemplateRef: string;
    private dw;
    rowEditTextTemplateRef: string;
    private dj;
    rowAddTextTemplateRef: string;
    private ds;
    rowEditActionsTemplateRef: string;
    private dx;
    rowExpandedIndicatorTemplateRef: string;
    private dl;
    rowCollapsedIndicatorTemplateRef: string;
    private c5;
    headerExpandIndicatorTemplateRef: string;
    private c4;
    headerCollapseIndicatorTemplateRef: string;
    private ct;
    excelStyleHeaderIconDirectiveTemplateRef: string;
    private cu;
    excelStyleHeaderIconTemplateRef: string;
    private d7;
    sortAscendingHeaderIconTemplateRef: string;
    private d8;
    sortDescendingHeaderIconDirectiveTemplateRef: string;
    private d9;
    sortDescendingHeaderIconTemplateRef: string;
    private ea;
    sortHeaderIconTemplateRef: string;
    private n;
    toolbar: WebGridToolbarDescription[];
    private l;
    paginationComponents: WebPaginatorDescription[];
    private ae;
    resourceStrings: WebGridResourceStringsDescription;
    private cy;
    filteringLogic: string;
    private x;
    filteringExpressionsTree: WebFilteringExpressionsTreeDescription;
    private w;
    advancedFilteringExpressionsTree: WebFilteringExpressionsTreeDescription;
    private c8;
    locale: string;
    private dc;
    pagingMode: string;
    private ax;
    paging: boolean;
    private bi;
    page: number;
    private bj;
    perPage: number;
    private at;
    hideRowSelectors: boolean;
    private ay;
    rowDraggable: boolean;
    private ei;
    validationTrigger: string;
    private bs;
    dragRowID: any;
    private az;
    rowEditable: boolean;
    private bt;
    rowHeight: any;
    private cg;
    columnWidth: string;
    private cq;
    emptyGridMessage: string;
    private au;
    isLoading: boolean;
    private a1;
    shouldGenerate: boolean;
    private cn;
    emptyFilteredGridMessage: string;
    private ak;
    pinning: WebPinningConfigDescription;
    private ap;
    allowFiltering: boolean;
    private ao;
    allowAdvancedFiltering: boolean;
    private cz;
    filterMode: string;
    private ef;
    summaryPosition: string;
    private ee;
    summaryCalculationMode: string;
    private a2;
    showSummaryOnCollapse: boolean;
    private aa;
    filterStrategy: WebFilteringStrategyDescription;
    private ag;
    sortStrategy: WebGridSortingStrategyDescription;
    private am;
    sortingOptions: WebSortingOptionsDescription;
    private d6;
    selectedRowsRef: string;
    private c6;
    headSelectorTemplateRef: string;
    private d2;
    rowSelectorTemplateRef: string;
    private cm;
    dragIndicatorIconTemplateRef: string;
    private m;
    sortingExpressions: WebSortingExpressionDescription[];
    private ar;
    batchEditing: boolean;
    private b4;
    cellSelection: string;
    private d0;
    rowSelection: string;
    private cc;
    columnSelection: string;
    private av;
    isPivot: boolean;
    private ai;
    outlet: WebOverlayOutletDirectiveDescription;
    private k;
    columns: WebColumnDescription[];
    private bm;
    totalRecords: number;
    private as;
    hasVisibleColumns: boolean;
    private a0;
    selectRowOnClick: boolean;
    private cx;
    filteringExpressionsTreeChangeRef: string;
    private by;
    advancedFilteringExpressionsTreeChangeRef: string;
    private c3;
    gridScrollRef: string;
    private da;
    pageChangeRef: string;
    private dd;
    perPageChangeRef: string;
    private bz;
    cellClickRef: string;
    private c0;
    formGroupCreatedRef: string;
    private eh;
    validationStatusChangeRef: string;
    private d5;
    selectedRef: string;
    private d1;
    rowSelectionChangingRef: string;
    private cd;
    columnSelectionChangingRef: string;
    private b9;
    columnPinRef: string;
    private ca;
    columnPinnedRef: string;
    private b2;
    cellEditEnterRef: string;
    private b3;
    cellEditExitRef: string;
    private b0;
    cellEditRef: string;
    private b1;
    cellEditDoneRef: string;
    private du;
    rowEditEnterRef: string;
    private dr;
    rowEditRef: string;
    private dt;
    rowEditDoneRef: string;
    private dv;
    rowEditExitRef: string;
    private b5;
    columnInitRef: string;
    private eb;
    sortingRef: string;
    private ec;
    sortingDoneRef: string;
    private cv;
    filteringRef: string;
    private cw;
    filteringDoneRef: string;
    private db;
    pagingDoneRef: string;
    private di;
    rowAddedRef: string;
    private dn;
    rowDeletedRef: string;
    private dm;
    rowDeleteRef: string;
    private dh;
    rowAddRef: string;
    private cb;
    columnResizedRef: string;
    private ch;
    contextMenuRef: string;
    private ck;
    doubleClickRef: string;
    private cf;
    columnVisibilityChangingRef: string;
    private ce;
    columnVisibilityChangedRef: string;
    private b8;
    columnMovingStartRef: string;
    private b6;
    columnMovingRef: string;
    private b7;
    columnMovingEndRef: string;
    private c2;
    gridKeydownRef: string;
    private dq;
    rowDragStartRef: string;
    private dp;
    rowDragEndRef: string;
    private c1;
    gridCopyRef: string;
    private d4;
    rowToggleRef: string;
    private dz;
    rowPinningRef: string;
    private dy;
    rowPinnedRef: string;
    private bw;
    activeNodeChangeRef: string;
    private ed;
    sortingExpressionsChangeRef: string;
    private eg;
    toolbarExportingRef: string;
    private df;
    rangeSelectedRef: string;
    private dg;
    renderedRef: string;
    private cj;
    dataChangingRef: string;
    private ci;
    dataChangedRef: string;
}
/**
 * @hidden
 */
export declare class WebGridToolbarDescription extends WebDisplayDensityBaseElementDescription {
    static $t: Type;
    protected get_type(): string;
    constructor();
    private o;
    showProgress: boolean;
    private m;
    grid: WebGridBaseDirectiveDescription;
    private q;
    name: string;
    private k;
    tools: WebGridToolbarContentDescription[];
}
