import { DataLegendSeriesGroup } from "./DataLegendSeriesGroup";
import { IgcDataLegendSeriesValueInfo } from "./igc-data-legend-series-value-info";
import { DataLegendSeriesValueType } from "./DataLegendSeriesValueType";
import { DataLegendSeriesContext as DataLegendSeriesContext_internal } from "./DataLegendSeriesContext";
/**
 * Represent info about series values
*/
export declare class IgcDataLegendSeriesContext {
    protected createImplementation(): DataLegendSeriesContext_internal;
    protected _implementation: any;
    /**
     * @hidden
     */
    readonly i: DataLegendSeriesContext_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * Gets a group of series that the current series belongs to
    */
    seriesGroup: DataLegendSeriesGroup;
    findByName(name: string): any;
    /**
     * Creates an instance of DataLegendSeriesContext
    
    */
    getSeriesValueInfo(type: DataLegendSeriesValueType): IgcDataLegendSeriesValueInfo;
    /**
     * Gets value info for the series value type
    
    */
    getSeriesValue(type: DataLegendSeriesValueType): number;
    setSeriesValue(type: DataLegendSeriesValueType, value: number): void;
    setSeriesValueInfo(type: DataLegendSeriesValueType, valueInfo: IgcDataLegendSeriesValueInfo): void;
    /**
     * Gets all values that a series renders at the current data point
     * For example, Open, High, Low, Close for Financial Series
    
    */
    getSeriesValues(): number[];
}
