import { IgcDataLegendSeriesValueInfo } from "./igc-data-legend-series-value-info";
import { DataLegendSummaryColumn as DataLegendSummaryColumn_internal } from "./DataLegendSummaryColumn";
/**
 * Represent a column in summary row
*/
export declare class IgcDataLegendSummaryColumn extends IgcDataLegendSeriesValueInfo {
    protected createImplementation(): DataLegendSummaryColumn_internal;
    /**
                                 * @hidden
                                 */
    readonly i: DataLegendSummaryColumn_internal;
    constructor();
    /**
     * Get values of series in the summary column
    */
    readonly seriesValues: number[];
    /**
     * Get labels rendered on left side of series values, e.g. "H:" for High, "L:" for Low
    */
    readonly seriesLabels: string[];
    /**
     * Get optional units on right side of series values, e.g. "Hz" for hertz
    */
    readonly seriesUnits: string[];
    /**
     * Add a value in the summary column
    
    */
    addValue(value: number): void;
    /**
     * Add label in the summary column
    
    */
    addLabel(label: string): void;
    /**
     * Add unit in the summary column
    
    */
    addUnits(units: string): void;
}
